#ifdef HAVE_LIBPTHREAD
#define LOCK pthread_mutex_lock(&counter_stream_lock)
#define UNLOCK pthread_mutex_unlock(&counter_stream_lock)

#define MCRYPT_LOCK_ALL for (i=0;i<max_streams_to_date;i++) { \
			pthread_mutex_lock( &streams[i].mcrypt_lock); }
#define MCRYPT_UNLOCK_ALL for (i=0;i<max_streams_to_date;i++) { \
			pthread_mutex_unlock( &streams[i].mcrypt_lock); }
#define MCRYPT_LOCK pthread_mutex_lock( &streams[td].mcrypt_lock)
#define MCRYPT_UNLOCK pthread_mutex_unlock( &streams[td].mcrypt_lock)
#define LT_LOCK pthread_mutex_lock( &lt_mutex_lock)
#define LT_UNLOCK pthread_mutex_unlock( &lt_mutex_lock)
#else
#define LOCK
#define UNLOCK
#define MCRYPT_LOCK_ALL
#define MCRYPT_UNLOCK_ALL
#define MCRYPT_LOCK
#define MCRYPT_UNLOCK
#define LT_LOCK
#define LT_UNLOCK
#endif


/* Local Defines */
void mcrypt_set_key(int, void *, void *, int, void *, int);
void mcrypt_block_encrypt(int, void *);
void mcrypt_block_decrypt(int, void *);
void mcrypt_stream_encrypt(int, void *, int);
void mcrypt_stream_decrypt(int, void *, int);

typedef struct {
	lt_dlhandle algorithm_handle;
	lt_dlhandle mode_handle;

	/* Holds the algorithm's internal key */
	word8 *akey;

	word8 *abuf;

	/* holds the key */
	word8 *keyword_given;

	/* holds a lock for the thread */
#ifdef HAVE_LIBPTHREAD
	pthread_mutex_t mcrypt_lock;
#endif

} CRYPT_STREAM;

#ifndef USE_MODULES
int algo_name2num(char *algorithm);
int mode_name2num(char *mode);
#endif


/* frontends */

int mcrypt_get_size(int td);
int mcrypt_mode_get_size(int td);
void mcrypt_set_key(int td, void *a, void *b, int c, void *d, int e);
int mcrypt_get_block_size(int td);
int __mcrypt_get_block_size(int td);
int mcrypt_get_algo_iv_size(int td);
int mcrypt_get_iv_size(int td);
int mcrypt_get_key_size(int td);
int* mcrypt_get_supported_key_sizes(int td, int* out_size);
int is_block_algorithm(int td);
char *mcrypt_get_algorithms_name(int td);
void mcrypt_block_encrypt(int td, void *b);
void mcrypt_block_decrypt(int td, void *b);
void mcrypt_stream_encrypt(int td, void *b, int c);
void mcrypt_stream_decrypt(int td, void *b, int c);
int init_mcrypt(int td, void*buf, void *a, int b, void *c);
int mcrypt(int td, void* buf, void *a, int b);
int mdecrypt(int td, void* buf, void *a, int b);
char *mcrypt_get_modes_name(int td);
int is_block_mode(int td);
int mcrypt_mode_has_iv(int td);
int is_block_algorithm_mode(int td);
int mcrypt_self_test(int td);
int mcrypt_module_self_test(char *algorithm, char *a_directory);
int mcrypt_algorithm_version(char *algorithm, char *a_directory);
int mcrypt_mode_version(char *mode, char *m_directory);
