#include "../../lib/libdefs.h"
#include "../../lib/mcrypt_modules.h"

#define _init_mcrypt cfb_LTX__init_mcrypt
#define _mcrypt cfb_LTX__mcrypt
#define _mdecrypt cfb_LTX__mdecrypt
#define _has_iv cfb_LTX__has_iv
#define _is_block_mode cfb_LTX__is_block_mode
#define _is_block_algorithm_mode cfb_LTX__is_block_algorithm_mode
#define _mcrypt_get_iv_size cfb_LTX__mcrypt_get_iv_size
#define _mcrypt_get_modes_name cfb_LTX__mcrypt_get_modes_name
#define _mcrypt_mode_get_size cfb_LTX__mcrypt_mode_get_size
#define _mcrypt_mode_version cfb_LTX__mcrypt_mode_version

typedef struct cfb_buf {
	word8 sd_register[32];
	word8 s_register[32];
	word8 enc_s_register[32];
	word8 enc_sd_register[32];
} CFB_BUFFER;

/* CFB MODE */

int _init_mcrypt( int td, CFB_BUFFER* buf, void *key, int lenofkey, void *IV)
{
/* For ofb */
	memmove(buf->sd_register, IV, __mcrypt_get_block_size(td));
	memmove(buf->s_register, IV, __mcrypt_get_block_size(td));

/* End ofb */

	return 0;

}

int _mcrypt(int td, CFB_BUFFER* buf, void *plaintext, int len)
{				/* plaintext is 1 byte (8bit cfb) */
	char *plain = plaintext;
	int i, j, blocksize = __mcrypt_get_block_size(td);

	for (j = 0; j < len; j++) {

		memmove(buf->enc_s_register, buf->s_register, blocksize);

		mcrypt_block_encrypt(td, buf->enc_s_register);

		plain[j] ^= buf->enc_s_register[0];

/* Shift the register */
		for (i = 0; i < (blocksize - 1); i++)
			buf->s_register[i] = buf->s_register[i + 1];

		buf->s_register[blocksize - 1] = plain[j];
	}

	return 0;

}


int _mdecrypt(int td, CFB_BUFFER* buf, void *plaintext, int len)
{				/* plaintext is 1 byte (8bit ofb) */
	char *plain = plaintext;
	int i, j, blocksize = __mcrypt_get_block_size(td);

	for (j = 0; j < len; j++) {

		memmove(buf->enc_sd_register, buf->sd_register, blocksize);

		mcrypt_block_encrypt(td, buf->enc_sd_register);

/* Shift the register */
		for (i = 0; i < (blocksize - 1); i++)
			buf->sd_register[i] = buf->sd_register[i + 1];

		buf->sd_register[blocksize - 1] = plain[j];

		plain[j] ^= buf->enc_sd_register[0];

	}

	return 0;
}

int _has_iv() { return 1; }
int _is_block_mode() { return 0; }
int _is_block_algorithm_mode() { return 1; }
char *_mcrypt_get_modes_name() { char*x; x=malloc(10); strcpy(x, "CFB"); return x;}
int _mcrypt_mode_get_size () {return sizeof(CFB_BUFFER);}
int _mcrypt_get_iv_size(int td) { return mcrypt_get_block_size(td); }


word32 _mcrypt_mode_version() {
	return 19991203;
}
